/*
  iiimqcplugin.cpp 
  Copyright (C) 2003 Free Standards Group

  Permission is hereby granted, free of charge, to any person obtaining a
  copy of this software and associated documentation files (the
  "Software"), to deal in the Software without restriction, including
  without limitation the rights to use, copy, modify, merge, publish,
  distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to
  the following conditions: The above copyright notice and this
  permission notice shall be included in all copies or substantial
  portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
  IN NO EVENT SHALL OPENI18N WG OR FREE STANDARDS GROUP. BE LIABLE
  FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH
  THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE EVEN IF
  ADVISED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.

  Except as contained in this notice, the names of OpenI18N WG and/or
  Free Standards Group shall not be used in advertising or otherwise to
  promote the sale, use or other dealings in this Software without prior
  written authorization from OpenI18N WG and/or Free Standards Group
  as applicable.

  Author: ILGYOUNG PARK <Karl.Park@Sun.COM>
	  TuBo	<Gavin.Tu@Sun.COM>

*/
#include <qinputcontextplugin.h>
#include <qinputcontext.h>

#include "iiimqccontext.h"
#include "debug.h"


class IIIMInputContextPlugin : public QInputContextPlugin
{
public:
    IIIMInputContextPlugin() : QInputContextPlugin() {
        DEBUG_DO(qDebug("**IIIMQCF: IIIMInputContextPlugin()"));
    }

    ~IIIMInputContextPlugin()
    {
        DEBUG_DO(qDebug("**IIIMQCF: ~IIIMInputContextPlugin()"));
    }

    QStringList keys() const {
        QStringList keylist;
        keylist.push_back("iiimqcf");
        DEBUG_DO(qDebug("**IIIQCF: IIIMInputContextPlugin, keys return iiimqcf"));
        return keylist;
    }

    QStringList languages(const QString&) {  //FIXME
        return QStringList("");
    }

    QString description(const QString&) {
        return QString::fromUtf8(tr("Qt immodule plugin for IIIM"));
    }

    QInputContext *create(const QString &s ) {
        if (s.lower() != "iiimqcf") {
            return 0;
        }
        DEBUG_DO(qDebug("**IIIQCF: IIIMInputContextPlugin, create QInputContext"));
        /*return   IIIMInputContext::getIIIMInputContext();*/
	return new IIIMInputContext;
    }

    QString displayName( const QString &key ) {
	    return key;
    }
};

Q_EXPORT_PLUGIN(IIIMInputContextPlugin)
